# Examples

In this directory you will find examples for the anax library. These examples will provide basic code, which focuses on specific features of a game.

Here are the examples that are contained with the library, at the current time:

1. Rendering
	- An example that shows how to render objects.
2. Animation
	- An example that shows how to implement simple 2D frame-by-frame animation.
3. Movement
	- An example that shows how to move objects around.
4. Collision
	- An example that shows basic bounding box collision.

> #### **NOTES**
> 1. An example may or may not use the previous example cocepts (e.g. to see movement you must know how to render objects). 
> 2. Most examples have the code contained within the `/common` directory, check the `README.md` in each example to see what code to look at.


## Dependencies

In order to compile the examples, you will need the following library(ies):

- [SFML]
	- [SFML] used because it is quite simple & straightforward, plus most people know how to use it.
	
It is reccomended that you understand how to use SFML, even though it is quite straight-foward.

## Examples To Come

These are the following examples that will be present in the library in the future.

1. AI Follow
	- An example that shows some simple AI within an entity system.
2. Simple Shooter
	- An extremely simple game with all of the concepts gathered from previous examples. This example also has AI that will shoot at the player.
3. Serialisation
	- An example that shows a way to serialize your entities within your game
4. Networking
	- Integrating networking with anax

[SFML]: http://www.sfml-dev.org/
